Summary: A high-performance mail store with IMAP and POP3 support.
Name: cyrus-imapd
Version: 2.0.9
Release: 5
Copyright: BSD
Group: System Environment/Daemons
URL: http://asg.web.cmu.edu/cyrus/imapd/
Source0: ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/cyrus-imapd-%{version}.tar.bz2
Source1: cyrus-README
Source2: cyrus-procmailrc
Source3: cyrus-deliver-wrapper.c
Source4: cyrus-user-procmailrc.template
Source5: cyrus-redhat-procmail+cyrus.mc
Source6: sendmail.cyrus.mc
Source7:  cyrus-imapd.logrotate
Source8:  cyrus-imapd.conf
Source9:  cyrus-imapd.pop.pamd
Source10: cyrus-imapd.imap.pamd
Source11: cyrus-imapd.cron
Source12: cyrus-imap-sasl.conf
Source13: cyrus-imapd-master.conf
Source14: cyrus-imapd-rc

Patch0: cyrus-imapd-2.0.5-dup.patch
Patch1: cyrus-imapd-2.0.5-pollute.patch
Patch2: cyrus-imapd-2.0.5-mandir.patch
Patch3: cyrus-imapd-2.0.9-cflags.patch
BuildRoot: %{_tmppath}/%{name}-root
Requires: cyrus-sasl, db3 
BuildPrereq: cyrus-sasl, e2fsprogs-devel, perl, tcp_wrappers, db3, db3-devel
BuildPrereq: sendmail-cf >= 8.11.2-7
Prereq: /usr/sbin/useradd, /usr/sbin/groupadd, /usr/sbin/usermod
Conflicts: imap

%description
The Cyrus IMAP server is a scaleable enterprise mail system
designed for use from small to large enterprise environments using
standards-based technologies.

A full Cyrus IMAP implementation allows a seamless mail and bulletin
board environment to be set up across multiple servers. It differs from
other IMAP server implementations in that it is run on "sealed"
servers, where users are not normally permitted to log in. The mailbox
database is stored in parts of the filesystem that are private to the
Cyrus IMAP system. All user access to mail is through software using
the IMAP, POP3, or KPOP protocols.

%prep
%setup -q
%patch0 -p1 -b .dup
%patch1 -p1 -b .pollute
%patch2 -p1 -b .mandir
%patch3 -p1 -b .cflags
find doc -name CVS -type d | xargs -r rm -fr
cp -f $RPM_SOURCE_DIR/sendmail.cyrus.mc .

%build
perl -pi -e "s#db-3#db-3.1#" configure configure.in

CPPFLAGS="-I/usr/include/et -I/usr/include/db3 -I/usr/include/db1"
export CPPFLAGS
CFLAGS="$RPM_OPT_FLAGS -fPIC"
export CFLAGS

pushd makedepend
./configure
make
popd

%configure \
	--enable-netscapehack --without-ucdsnmp \
	--with-krb=/usr/kerberos  --with-perl=%{__perl} \
	--with-libwrap=%{_prefix} --with-openssl=%{_prefix}
make -C imap imap_err.o
make MAKEDEPEND=: all
gcc -Wall -o deliver-wrapper $RPM_SOURCE_DIR/cyrus-deliver-wrapper.c

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

# First create the 'cyrus' user if it doesn't exist
/usr/sbin/useradd -c "Cyrus IMAPd Owner" -d /var/imap -g mail -s /bin/sh -u 76 -r cyrus 2>&1 >/dev/null ||:
/usr/sbin/groupadd -r -g 76 shadow 2>&1 >/dev/null ||:
/usr/sbin/usermod -G shadow cyrus 2>&1 >/dev/null ||:
/usr/sbin/usermod -s /bin/sh cyrus 2>&1 >/dev/null ||:

# Do what the regular make install does.
install -d $RPM_BUILD_ROOT{%{_bindir},%{_includedir}/cyrus,%{_libdir}}
install -d $RPM_BUILD_ROOT%{_mandir}/man{1,3,5,8}
make install DESTDIR=$RPM_BUILD_ROOT PREFIX=$RPM_BUILD_ROOT%{_prefix} CYRUS_USER=`id -un` CYRUS_GROUP=`id -gn` mandir=%{_mandir}
make -C man install DESTDIR=$RPM_BUILD_ROOT PREFIX=$RPM_BUILD_ROOT%{_prefix} CYRUS_USER=`id -un` CYRUS_GROUP=`id -gn` mandir=%{_mandir}

# Create directories.
mkdir -p $RPM_BUILD_ROOT/etc/{cron.daily,logrotate.d,pam.d,mail}
mkdir -p $RPM_BUILD_ROOT/usr/{cyrus/{bin,etc},share/sendmail-cf/cf,sbin}

# Install the delivery agent.
install -s deliver-wrapper $RPM_BUILD_ROOT/usr/cyrus/bin/deliver-wrapper

install -m 755 imtest/imtest $RPM_BUILD_ROOT/usr/cyrus/bin/imtest
install -m 755 perl/imap/cyradm $RPM_BUILD_ROOT/usr/cyrus/bin/cyradm

# Install various configuration files.
install -m 644 %{SOURCE8} $RPM_BUILD_ROOT/etc/imapd.conf
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT/etc/procmailrc.cyrus
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT/usr/cyrus/etc/user-procmailrc.template
install -m 644 %{SOURCE7} $RPM_BUILD_ROOT/etc/logrotate.d/cyrus-imapd
install -m 755 %{SOURCE11} $RPM_BUILD_ROOT/etc/cron.daily/cyrus-imapd

# Build and populate /var/spool and /var/imap.
mkdir -p -m 0755 $RPM_BUILD_ROOT/var/spool/imap
mkdir -p -m 0755 $RPM_BUILD_ROOT/var/spool/imap/stage.
mkdir -p -m 0755 $RPM_BUILD_ROOT/var/imap/{user,quota,proc,log,msg,deliverdb,deliverdb/db,socket,db}
touch    $RPM_BUILD_ROOT/var/imap/mailboxes
export IMAP_DIR="$RPM_BUILD_ROOT/var/imap/"
echo "IMAP_DIR: $IMAP_DIR"
perl -e 'foreach ("a".."z") { mkdir "$ENV{IMAP_DIR}/user/$_",0755; mkdir "$ENV{IMAP_DIR}/quota/$_",0755; }'

# Make symlinks where they're expected to be found.
ln -s ../cyrus/bin/imapd $RPM_BUILD_ROOT/usr/sbin/imapd
ln -s ../cyrus/bin/pop3d $RPM_BUILD_ROOT/usr/sbin/ipop3d

# Install stuff for generating Cyrus-friendly Sendmail configuration files.
install -m 644 sendmail.cyrus.mc $RPM_BUILD_ROOT/etc/mail/sendmail.cyrus.mc
savedir=`pwd`
pushd /usr/share/sendmail-cf/cf
./Build ${savedir}/sendmail.cyrus.cf
popd
install -m 644 sendmail.cyrus.cf $RPM_BUILD_ROOT/etc/mail/sendmail.cyrus.cf

# Enable sasl login using sasldb.
mkdir -p $RPM_BUILD_ROOT/usr/lib/sasl
install -m 644 %{SOURCE12} $RPM_BUILD_ROOT/usr/lib/sasl/Cyrus.conf

# Add the necessary config files to /etc/pam.d
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
install -m 644 %{SOURCE9} $RPM_BUILD_ROOT/etc/pam.d/pop
install -m 644 %{SOURCE10} $RPM_BUILD_ROOT/etc/pam.d/imap

# Install the /etc/cyrus.conf file that controls master process
install -m 644 %{SOURCE13} $RPM_BUILD_ROOT/etc/cyrus.conf

# Install rc script
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 %{SOURCE14} $RPM_BUILD_ROOT/etc/rc.d/init.d/cyrus

# Install the tools
for tool in tools/* ; do
	test -f ${tool} && install -m755 ${tool} $RPM_BUILD_ROOT/usr/cyrus/bin/
done

# Install a SASL database.
mkdir -p $RPM_BUILD_ROOT/etc
install /dev/null $RPM_BUILD_ROOT/etc/sasldb

mkdir -p $RPM_BUILD_ROOT%{_bindir}
ln -s -f ../cyrus/bin/cyradm ../cyrus/bin/imtest $RPM_BUILD_ROOT/%{_bindir}/

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%pre
if ! grep -q ^cyrus: /etc/passwd ; then
	/usr/sbin/useradd -c "Cyrus IMAPd Owner" -d /var/imap -g mail -s /bin/bash -u 76 -r cyrus ||:
	/usr/sbin/usermod -s /bin/bash cyrus ||:
	/usr/sbin/groupadd -r -g 76 shadow ||:
	/usr/sbin/usermod -G shadow cyrus ||:
fi

%post
# force synchronous updates
# Note: This will slow down user creation for 10.000+ users!
chattr -R +S /var/imap user quota 2>/dev/null
chattr -R +S /var/spool/imap 2>/dev/null
/sbin/chkconfig --add cyrus
install -m600 -o cyrus -g mail /dev/null /var/log/imapd.log
su cyrus -c /usr/cyrus/bin/mkimap 2>&1 > /dev/null || :

%preun
if [ $1 = 0 ] ; then
	/sbin/service cyrus stop
	/sbin/chkconfig --del cyrus
fi

%postun
if [ $1 -ge 1 ] ; then
	/sbin/service cyrus condrestart 2>&1 > /dev/null
fi

%files
%defattr(-,root,root)
%doc COPYRIGHT README doc/*
%config /etc/cron.daily/*
%config /etc/cyrus.conf
%config /etc/imapd.conf
%config /etc/logrotate.d/*
%config /etc/mail/sendmail.cyrus.mc
%config /etc/mail/sendmail.cyrus.cf
%config /etc/pam.d/*
%config /etc/procmailrc.cyrus
%config /etc/rc.d/init.d/cyrus
%attr(0600,cyrus,mail) %config(noreplace) /etc/sasldb
%config %{_libdir}/sasl/Cyrus.conf
%dir /usr/cyrus
%dir /usr/cyrus/bin
#/usr/cyrus/bin/arbitron
#/usr/cyrus/bin/collectnews
/usr/cyrus/bin/ctl_mboxlist
/usr/cyrus/bin/ctl_deliver
/usr/cyrus/bin/cyradm
/usr/cyrus/bin/deliver
%attr(02755,cyrus,mail) /usr/cyrus/bin/deliver-wrapper
/usr/cyrus/bin/dohash
#/usr/cyrus/bin/dump_deliverdb
/usr/cyrus/bin/feedcyrus
/usr/cyrus/bin/fud
/usr/cyrus/bin/imapd
/usr/cyrus/bin/imtest
/usr/cyrus/bin/lmtpd
/usr/cyrus/bin/master
/usr/cyrus/bin/mbpath
/usr/cyrus/bin/mkimap
/usr/cyrus/bin/not-mkdep
/usr/cyrus/bin/pop3d
/usr/cyrus/bin/quota
/usr/cyrus/bin/reconstruct
#/usr/cyrus/bin/syncnews
/usr/cyrus/bin/timsieved
/usr/cyrus/bin/undohash
/usr/cyrus/bin/upgradesieve

%config /usr/cyrus/etc

%{_bindir}/*
%{_includedir}/cyrus
%{_libdir}/perl?/site_perl/*/*/auto/Cyrus
%{_libdir}/perl?/site_perl/*/*/Cyrus
#%{_datadir}/sendmail-cf/cf/redhat-procmail+cyrus.mc
%{_libdir}/*.a
%{_mandir}/*/*
%{_sbindir}/*
%attr(750,cyrus,mail) /var/imap
%attr(750,cyrus,mail) /var/spool/imap

%changelog
* Wed Aug 29 2001 Peter Hanecak <hanecak@megaloman.com>
- .bz2 source archiv

* Fri Mar  2 2001 Tim Powers <timp@redhat.com>
- rebuilt against openssl-0.9.6-1

* Thu Feb 15 2001 Nalin Dahyabhai <nalin@redhat.com>
- fix the init script (#19016)
- use ctl_deliver instead of deliver to prune databases (#20898)

* Sat Jan 20 2001 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.9
- disable snmp support
- honor CFLAGS when building the perl sieve library

* Mon Oct 23 2000 Nalin Dahyabhai <nalin@redhat.com>
- add config directive to make sendmail use a group-writable sasldb
- drop nossl patch

* Wed Sep  6 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.7 (#17257)
- drop out patch 4

* Tue Aug 22 2000 Nalin Dahyabhai <nalin@redhat.com>
- give cyrus a real shell
- use chattr -R when making directory updates synchronous

* Thu Aug 18 2000 Nalin Dahyabhai <nalin@redhat.com>
- enable SSL support

* Tue Aug  8 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.6 to get lots of bug fixes
- enable built-in tcp_wrapper support
- make the scripts in %{_bindir} symlinks to their counterparts
- fix the scripts to test $1 and not $?

* Mon Aug  7 2000 Nalin Dahyabhai <nalin@redhat.com>
- change sasldb perms to 0600 because sendmail would complain

* Fri Aug  4 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix PAM configuration files

* Thu Aug  3 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix cyrus's shell so that cyradm will actually start
- create a log file so that logrotate won't spit out useless warnings
- include all of the man pages
- tag files in /usr/cyrus/etc as config files
- tweak sendmail.cyrus.mc to be more similar to sendmail.mc
- remove redhat-procmail+cyrus.mc

* Fri Jul 28 2000 Than Ngo <than@redhat.de>
- add missing restart function in startup script

* Fri Jul 28 2000 Tim Powers <timp@redhat.com>
- fixed initscript so that condrestart won't return 1 when the test fails

* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Wed Jul 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- re-enable Kerberos
- add condrestart to the init script and rename it to "cyrus"
- use chkconfig to manage links

* Mon Jul 10 2000 Todd Nemanich <todd@baymountain.com>
- Correctly populated /var/imap
- Added /etc/cyrus.conf for master process
- Added LDFLAGS and configure fix to correctly link /lib/db-3.1.so
- Added master, cyradm, ctl_mboxlist, ctl_deliver to install list
- Added standalone rc script

* Thu Jun 15 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 2.0.5
- remove %%pre that was useless without its %%post

* Fri Feb 11 2000 Tim Powers <timp@redhat.com>
- fixed man pages not being gzipped.

* Tue Nov 16 1999 Tim Powers <timp@redhat.com>
- incorporated changes from Mads Kiilerich
- release is not mk1, it's 1

* Tue Nov 10 1999 Mads Kiilerich <mads@kiilerich.com>
- updated source to 1.6.19
- removed configure --with-login=unix 
- added configure --with-com_err=yes
- made it less sendmail-centric [postfix rules!] 
- PAMified: /usr/lib/sasl/Cyrus.conf uses PAM, and pop and imapd installed
  in /etc/pam.d.
- adds cyrus user to shadow group (if it exists) so that pam can be used even
  when /etc/shadow is used.
- use useradd, userdel and usermod for changes in system files
- added documentation
- fix /var/imap owner problems

* Fri Aug 13 1999 Tim Powers <timp@redhat.com>
- updated source
- quiet setup
- updated URL
- changed spec file so that sendmail.cf is not generated. 
- now requires cyrus-sasl to build
- moved changelog to the bottom
- first build for Powertools

* Wed Feb 24 1999 Brian Candler
- Implemented the deliver-wrapper; now users can securely manage their
  own .procmailrc

* Tue Feb 16 1999 Brian Candler
- Removed 'Packager:' line. It is annoying when someone changes what
  you've done but leaves you in to take the blame :-)
- Updated to 1.5.19
- Fixed sendmail.cf handling

* Sun Aug 16 1998 joerg@cogito.de
- procmail/sendmail configuration added, based on
  http://www.ncworldmag.com/ncw-05-1998/ncw-05-imap.html
